#!/usr/bin/perl

use warnings;
use strict;
use Tk;
use Tk::BrowseEntry;
use Tk::MsgBox;
use Tk::PNG;
use Tk::JPEG;
use Tk::LabEntry;
use Tk::LabFrame;
use Tk::DirSelect;
use Tk::ROText;
use Tk::ProgressBar;
use Cwd;
use File::Spec;

my $button_size = 10;
my $linux_distro = 'Ubuntu 12.04';
my $stdbuf_str = "stdbuf -oL";
my $pid;
my $tab = 1;
my $app_launcher_pro = 1;
my $app_launcher = 1;
my $install_dir;
#my $launch = 1;
my ($progress, $progress_pr);
my ($pdb2pqr, $gromacs, $ligbuilder, $ligbuilder_2, $pharmACOphore, $pymol) = (1,1,1,1,1,1);
my ($pdb2pqr_file, $ligbuilder_file, $ligbuilder_2_file, $pharmACOphore_file);
my ($pdb2pqr_dir, $ligbuilder_dir, $ligbuilder_2_dir, $pharmACOphore_dir);
my @deps_u_13_10 = qw#---Repository--- openbabel perl perl-tk libtk-tablematrix-perl libtk-dirselect-perl libfile-homedir-perl liblist-moreutils-perl libsys-statistics-linux-perl libwww-mechanize-perl cpanminus ---CPAN--- ./Supplementary_Files/cpanm/Test-Sys-Info-0.20.tar.gz ./Supplementary_Files/cpanm/Unix-Processors-2.042.tar.gz ./Supplementary_Files/cpanm/Config-General-2.51.tar.gz ./Supplementary_Files/cpanm/Sys-Info-Base-0.7802.tar.gz ./Supplementary_Files/cpanm/Sys-Info-Driver-Linux-0.7900.tar.gz ./Supplementary_Files/cpanm/Sys-Info-0.78.tar.gz#;
my @deps_u_12_04 = qw#---Repository--- openbabel perl perl-tk libtk-tablematrix-perl libtk-dirselect-perl libfile-homedir-perl liblist-moreutils-perl libsys-statistics-linux-perl libwww-mechanize-perl cpanminus ---CPAN--- ./Supplementary_Files/cpanm/Test-Sys-Info-0.20.tar.gz ./Supplementary_Files/cpanm/Unix-Processors-2.042.tar.gz ./Supplementary_Files/cpanm/Config-General-2.51.tar.gz ./Supplementary_Files/cpanm/Sys-Info-Base-0.7802.tar.gz ./Supplementary_Files/cpanm/Sys-Info-Driver-Linux-0.7900.tar.gz ./Supplementary_Files/cpanm/Sys-Info-0.78.tar.gz#;
my @deps = @deps_u_12_04;
my $mw = new MainWindow(-title => 'Install DrugOn');
$mw->withdraw;
$mw->geometry("420x590+450+75");
$mw->resizable(0,0);
$pdb2pqr_dir = '/var/www/html/pdb2pqr';
# $mw->update;

my $abs_drugOn_file = File::Spec->rel2abs($0);
my ($volume,$directories,$drug_file) = File::Spec->splitpath($abs_drugOn_file);
my $drugOn_directory = $directories;

my $folder_button_image = $mw->Photo(-format => 'png', -file => File::Spec->catfile($drugOn_directory,'Icons/folder1.png'));
my $program_image = $mw->Photo(-format => 'png' , -file => File::Spec->catfile($drugOn_directory,'Icons/DrugOn-small.png'));
my $browse_button_image = $mw->Photo(-format => 'png', -file => File::Spec->catfile($drugOn_directory,'Icons/folder2.png'));
#my $thumbs_up_image = $mw->Photo(-format => 'jpeg', -file => File::Spec->catfile($drugOn_directory,'Icons/Green-thumb.jpg'));
# print $mw->screenwidth;
# print $mw->screenheight;

my $main_frame = $mw->Frame(-borderwidth=>2, -relief=>'raised')->pack(-side => 'top', -anchor => 'nw', -expand => 1, -fill => 'both');
my $button_frame = $mw->Frame(-borderwidth=>2, -relief=>'raised')->pack(-side => 'bottom', -anchor => 'sw', -expand => 0, -fill => 'x');

#$program_image->pack(-side => 'top');
my $title_frame = $main_frame->Frame(-borderwidth=>1, -relief=>'flat', -background => 'white')->pack(-side => 'top', -anchor => 'nw', -expand => 0, -fill => 'both');
my $title_label= $title_frame->Label(-text=>"Welcome to DrugOn installation wizard.",-justify=>'center',-background => 'white')->pack(-side=>'left', -pady => 0,-padx=>0, -expand => 1, -fill => 'both');
my $program_frame = $title_frame->Label( -image => $program_image, -anchor=>'ne',-borderwidth=>0)->pack(-side=>'right', -pady => 0,-padx=>0, -expand => 0, -fill => 'both');
my $start_frame = $main_frame->Frame(-borderwidth=>2, -relief=>'flat')->pack(-side => 'top', -anchor => 'nw', -expand => 1, -fill => 'both');
my $main_label= $start_frame->Label(-text=>"\nThis wizard will help you install/update DrugOn and the necessary\nsoftware packages using mainly the native OS Package Manager.\n\nAn active internet connection is required.\n\nPress Next to begin.",-justify=>'left', -anchor=>'w',-borderwidth=>0)->pack(-side=>'top', -pady => 0,-padx=>0, -expand => 0, -fill => 'none');

my $note_label= $start_frame->Label(-text=>"NOTE: Installation process requires administrator rights.",-justify=>'left', -anchor=>'w',-borderwidth=>1)->pack(-side=>'bottom', -pady => 2,-padx=>2, -expand => 0, -fill => 'x');

my $drdep_frame = $main_frame->Frame(-borderwidth=>2, -relief=>'flat');
my $sub_linux_frame = $drdep_frame->LabFrame(-label => "OS Selection", -labelside => "acrosstop")->pack(-side => 'top', -anchor => 'nw', -expand => 1, -fill => 'both');
my $linux_label= $sub_linux_frame->Label(-text=>"Select the appropriate Linux distribution from the drop-down\nmenu.",-justify=>'left', -anchor=>'w',-borderwidth=>1)->pack(-side=>'top', -pady => 1,-padx=>1, -expand => 0, -fill => 'x');
my $linux_entry = $sub_linux_frame->BrowseEntry( -label => 'Linux Distribution: ', -labelPack => [ -side => "left" ], -textvariable => \$linux_distro, -insertofftime => 0, -browsecmd => \&linux_entry_callback, -state => 'readonly', -disabledforeground => 'black');
$linux_entry->insert("end", "Ubuntu 13.10");
$linux_entry->insert("end", "Ubuntu 12.04");
$linux_entry->pack( -side => 'top', -padx => 5, -pady => 1, -fill => 'both', -expand => 0);
my $linux_dep_frame = $sub_linux_frame->Frame()->pack(-side => 'bottom', -expand => 1, -fill => 'both');
my $linux_dep_list= $linux_dep_frame->Listbox(-borderwidth=>1, -activestyle => 'none', -state => 'disabled', -disabledforeground => 'black', -height => 5, -listvariable => \@deps)->pack(-side=>'right', -pady => 3,-padx=>6, -expand => 1, -fill => 'both');
my $linux_dep_label= $linux_dep_frame->Label(-text=>"Packages to be installed/updated\n(Scroll down to see full list):",-justify=>'right', -anchor=>'nw',-borderwidth=>1)->pack(-side=>'right', -pady => 1,-padx=>1, -expand => 0, -fill => 'y');

my $drugOn_frame = $drdep_frame->LabFrame(-label => "Installation Folder", -labelside => "acrosstop")->pack(-side => 'bottom', -anchor => 'nw', -expand => 0, -fill => 'both');
my $drugOn_label= $drugOn_frame->Label(-text=>"Specify location to install DrugOn.",-justify=>'left', -anchor=>'w',-borderwidth=>0)->pack(-side=>'top', -pady => 2,-padx=>1, -expand => 0, -fill => 'x');
my $drugOn_int_frame = $drugOn_frame->Frame()->pack(-side => 'top', -expand => 0, -fill => 'both');
my $drugOn_entry = $drugOn_int_frame->LabEntry(-label => 'Path: ', -labelPack => [ -side => "left" ], -textvariable => \$install_dir, -background => 'white', -insertofftime => 0, -state => 'readonly', -readonlybackground => 'white')->pack(-side => 'left', -padx => 0,-pady => 2, -fill => 'x', -expand => 1);
my $drugOn_button = $drugOn_int_frame->Button(-text => '...',-image => $folder_button_image, -command => [\&browse_directory_callback,\$install_dir])->pack( -side => 'right', -padx => 4,-pady => 2);
my $drugOn_note_label= $drugOn_frame->Label(-text=>"NOTE: Install in a folder at your Home directory, since write access\n              is necessary when running the application. A folder named\n              drugOn_v1.1 will be created in the provided path.",-justify=>'left', -anchor=>'w',-borderwidth=>1)->pack(-side=>'bottom', -pady => 3,-padx=>2, -expand => 0, -fill => 'x');
my $drugOn_icon_frame = $drugOn_frame->Frame()->pack(-side => 'bottom', -anchor => 'nw', -expand => 0, -fill => 'both');
my $drugOn_pro_icon_frame = $drugOn_frame->Frame()->pack(-side => 'bottom', -anchor => 'nw', -expand => 0, -fill => 'both');
my $drugOn_pro_icon_label= $drugOn_pro_icon_frame->Label(-text=>"Create application launcher for DrugOn_pro:",-justify=>'left', -anchor=>'e',-borderwidth=>0)->pack(-side=>'left', -pady => 0,-padx=>0, -expand => 1, -fill => 'x');
my $drugOn_pro_icon_check= $drugOn_pro_icon_frame->Checkbutton( -variable => \$app_launcher_pro)->pack(-side => 'right', -padx => 0, -fill => 'none', -expand => 0);
my $drugOn_icon_label= $drugOn_icon_frame->Label(-text=>"Create application launcher for DrugOn:",-justify=>'left', -anchor=>'e',-borderwidth=>0)->pack(-side=>'left', -pady => 0,-padx=>0, -expand => 1, -fill => 'x');
my $drugOn_icon_check= $drugOn_icon_frame->Checkbutton( -variable => \$app_launcher)->pack(-side => 'right', -padx => 0, -fill => 'none', -expand => 0);

my $dr_install_frame = $main_frame->Frame(-borderwidth=>2, -relief=>'flat');
my $output_frame = $dr_install_frame->LabFrame(-label => "Installation Progress", -labelside => "acrosstop")-> pack( -side => 'top', -fill=>'both', -expand => 1, -anchor => 'e');
my $output_text = $output_frame->Scrolled('ROText', -scrollbars => 'osoe', '-wrap','none','-borderwidth', 1,'-background', 'white','-foreground', 'black','-relief', 'sunken','-height', 10, -insertofftime => 0)->pack(-anchor => 'nw', -fill => 'both', -expand => 1);
my $pb = $output_frame->ProgressBar(-variable=>\$progress,-width => 17,-blocks=>100,-gap => 2,-colors   => &rainbow)->pack(-fill=>'x', -expand =>1, -side=>'left',-padx => 2, -pady => 3);
$output_text->tagConfigure('orange', -font => "Courier -14 bold", -foreground=>'orange');
$output_text->tagConfigure('boldy', -font => "Courier -12 bold", -foreground=>'black');

my $add_install_frame = $main_frame->Frame(-borderwidth=>2, -relief=>'flat');
my $add_install_label= $add_install_frame->Label(-text=>"\ndrugOn employs functionality provided by the following applications.\nGromacs and Pymol can be installed directly from the OS repositories.\nFor the rest you will need to download the appropriate *.tar.gz files\nand provide their path in the corresponding entries (Read Manual for\ndetails). Setup will then handle package and dependency installation.",-justify=>'left', -anchor=>'w',-borderwidth=>0)->pack(-side=>'top', -pady => 0,-padx=>0, -expand => 0, -fill => 'none');
my $add_det_frame = $add_install_frame->LabFrame(-label => "Additional Software Installation", -labelside => "acrosstop")->pack(-side => 'top', -anchor => 'nw', -expand => 1, -fill => 'both');

my $pdb2pqr_frame = $add_det_frame->Frame(-borderwidth=>0, -relief=>'flat')->pack(-side => 'top', -fill => 'x', -expand => 0);
my $pdb2pqr_check= $pdb2pqr_frame->Checkbutton( -variable => \$pdb2pqr)->pack(-side => 'left', -padx => 2, -fill => 'none', -expand => 0, -anchor => 'w');
my $pdb2pqr_label= $pdb2pqr_frame->Label(-text=>"Pdb2pqr",-justify=>'left', -anchor=>'w',-borderwidth=>0)->pack(-side=>'left', -pady => 2,-padx=>0, -expand => 0, -fill => 'x');
my $pdb2pqr_file_button = $pdb2pqr_frame->Button(-text => '...',-image => $browse_button_image, -command => [\&browse_file_callback,\$pdb2pqr_file])->pack( -side => 'right', -padx => 4,-pady => 2);
my $pdb2pqr_file_entry = $pdb2pqr_frame->LabEntry(-label => '.tar.gz File: ', -labelPack => [ -side => "left" ], -textvariable => \$pdb2pqr_file, -background => 'white', -insertofftime => 0, -state => 'readonly', -readonlybackground => 'white')->pack(-side => 'right', -padx => 0,-pady => 2, -fill => 'x', -expand => 0);
my $gromacs_frame = $add_det_frame->Frame(-borderwidth=>0, -relief=>'flat')->pack(-side => 'top', -fill => 'x', -expand => 0);
my $gromacs_check= $gromacs_frame->Checkbutton( -variable => \$gromacs)->pack(-side => 'left', -padx => 2, -fill => 'none', -expand => 0, -anchor => 'w');
my $gromacs_label= $gromacs_frame->Label(-text=>"Gromacs",-justify=>'left', -anchor=>'w',-borderwidth=>0)->pack(-side=>'left', -pady => 2,-padx=>0, -expand => 0, -fill => 'x');
my $ligbuilder_frame = $add_det_frame->Frame(-borderwidth=>0, -relief=>'flat')->pack(-side => 'top', -fill => 'x', -expand => 0);
my $ligbuilder_check= $ligbuilder_frame->Checkbutton( -variable => \$ligbuilder)->pack(-side => 'left', -padx => 2, -fill => 'none', -expand => 0, -anchor => 'w');
my $ligbuilder_label= $ligbuilder_frame->Label(-text=>"LigBuilder ver. 1",-justify=>'left', -anchor=>'w',-borderwidth=>0)->pack(-side=>'left', -pady => 2,-padx=>0, -expand => 0, -fill => 'x');
my $ligbuilder_file_button = $ligbuilder_frame->Button(-text => '...',-image => $browse_button_image, -command => [\&browse_file_zip_callback,\$ligbuilder_file])->pack( -side => 'right', -padx => 4,-pady => 2);
my $ligbuilder_file_entry = $ligbuilder_frame->LabEntry(-label => '.zip File: ', -labelPack => [ -side => "left" ], -textvariable => \$ligbuilder_file, -background => 'white', -insertofftime => 0, -state => 'readonly', -readonlybackground => 'white')->pack(-side => 'right', -padx => 0,-pady => 2, -fill => 'x', -expand => 0);
my $ligbuilder_sec_frame = $add_det_frame->Frame(-borderwidth=>0, -relief=>'flat')->pack(-side => 'top', -fill => 'x', -expand => 0);
my $ligbuilder_dir_button = $ligbuilder_sec_frame->Button(-text => '...',-image => $folder_button_image, -command => [\&browse_directory_callback,\$ligbuilder_dir])->pack( -side => 'right', -padx => 4,-pady => 2);
my $ligbuilder_dir_entry = $ligbuilder_sec_frame->LabEntry(-label => 'Install in: ', -labelPack => [ -side => "left" ], -textvariable => \$ligbuilder_dir, -background => 'white', -insertofftime => 0, -state => 'readonly', -readonlybackground => 'white')->pack(-side => 'right', -padx => 0,-pady => 2, -fill => 'x', -expand => 0);
my $ligbuilder_2_frame = $add_det_frame->Frame(-borderwidth=>0, -relief=>'flat')->pack(-side => 'top', -fill => 'x', -expand => 0);
my $ligbuilder_2_check= $ligbuilder_2_frame->Checkbutton( -variable => \$ligbuilder_2)->pack(-side => 'left', -padx => 2, -fill => 'none', -expand => 0, -anchor => 'w');
my $ligbuilder_2_label= $ligbuilder_2_frame->Label(-text=>"LigBuilder ver. 2",-justify=>'left', -anchor=>'w',-borderwidth=>0)->pack(-side=>'left', -pady => 2,-padx=>0, -expand => 0, -fill => 'x');
my $ligbuilder_2_file_button = $ligbuilder_2_frame->Button(-text => '...',-image => $browse_button_image, -command => [\&browse_file_callback,\$ligbuilder_2_file])->pack( -side => 'right', -padx => 4,-pady => 2);
my $ligbuilder_2_file_entry = $ligbuilder_2_frame->LabEntry(-label => '.tar.gz File: ', -labelPack => [ -side => "left" ], -textvariable => \$ligbuilder_2_file, -background => 'white', -insertofftime => 0, -state => 'readonly', -readonlybackground => 'white')->pack(-side => 'right', -padx => 0,-pady => 2, -fill => 'x', -expand => 0);
my $ligbuilder_2_sec_frame = $add_det_frame->Frame(-borderwidth=>0, -relief=>'flat')->pack(-side => 'top', -fill => 'x', -expand => 0);
my $ligbuilder_2_dir_button = $ligbuilder_2_sec_frame->Button(-text => '...',-image => $folder_button_image, -command => [\&browse_directory_callback,\$ligbuilder_2_dir])->pack( -side => 'right', -padx => 4,-pady => 2);
my $ligbuilder_2_dir_entry = $ligbuilder_2_sec_frame->LabEntry(-label => 'Install in: ', -labelPack => [ -side => "left" ], -textvariable => \$ligbuilder_2_dir, -background => 'white', -insertofftime => 0, -state => 'readonly', -readonlybackground => 'white')->pack(-side => 'right', -padx => 0,-pady => 2, -fill => 'x', -expand => 0);
my $pha_frame = $add_det_frame->Frame(-borderwidth=>0, -relief=>'flat')->pack(-side => 'top', -fill => 'x', -expand => 0);
my $pha_check = $pha_frame->Checkbutton( -variable => \$pharmACOphore)->pack(-side => 'left', -padx => 2, -fill => 'none', -expand => 0, -anchor => 'w');
my $pha_label = $pha_frame->Label(-text=>"PharmACOphore",-justify=>'left', -anchor=>'w',-borderwidth=>0)->pack(-side=>'left', -pady => 2,-padx=>0, -expand => 0, -fill => 'x');
my $pharmacophore_file_button = $pha_frame->Button(-text => '...',-image => $browse_button_image, -command => [\&browse_file_callback,\$pharmACOphore_file])->pack( -side => 'right', -padx => 4,-pady => 2);
my $pharmacophore_file_entry = $pha_frame->LabEntry(-label => 'install from', -labelPack => [ -side => "left" ], -textvariable => \$pharmACOphore_file, -background => 'white', -insertofftime => 0, -state => 'readonly', -readonlybackground => 'white')->pack(-side => 'right', -padx => 0,-pady => 2, -fill => 'x', -expand => 0);
my $pymol_frame = $add_det_frame->Frame(-borderwidth=>0, -relief=>'flat')->pack(-side => 'top', -fill => 'x', -expand => 0);
my $pymol_check= $pymol_frame->Checkbutton( -variable => \$pymol)->pack(-side => 'left', -padx => 2, -fill => 'none', -expand => 0, -anchor => 'w');
my $pymol_label= $pymol_frame->Label(-text=>"Pymol",-justify=>'left', -anchor=>'w',-borderwidth=>0)->pack(-side=>'left', -pady => 2,-padx=>0, -expand => 0, -fill => 'x');
my $add_det_note_label= $add_det_frame->Label(-text=>"NOTE: Pdb2pqr installation is optional. It can be run through a web\n              server. Only one version of Ligbuilder is necessary\n              (Ligbuilder v2 is only for DrugOn pro).\n              Pymol instalation can be skipped if you have another favorite\n              molecular viewer.\n              Read manual for more details.",-justify=>'left', -anchor=>'w',-borderwidth=>1)->pack(-side=>'bottom', -pady => 3,-padx=>2, -expand => 0, -fill => 'x');
my $add_install_pr_frame = $main_frame->Frame(-borderwidth=>2, -relief=>'flat');
my $output_pr_frame = $add_install_pr_frame->LabFrame(-label => "Installation Progress", -labelside => "acrosstop")-> pack( -side => 'top', -fill=>'both', -expand => 1, -anchor => 'e');
my $output_pr_text = $output_pr_frame->Scrolled('ROText', -scrollbars => 'osoe', '-wrap','none','-borderwidth', 1,'-background', 'white','-foreground', 'black','-relief', 'sunken','-height', 10, -insertofftime => 0)->pack(-anchor => 'nw', -fill => 'both', -expand => 1);
my $pb_pr = $output_pr_frame->ProgressBar(-variable=>\$progress_pr,-width => 17,-blocks=>100,-gap => 0,-colors   => &rainbow)->pack(-fill=>'x', -expand =>1, -side=>'left',-padx => 2, -pady => 3);
$output_pr_text->tagConfigure('orange', -font => "Courier -14 bold", -foreground=>'orange');
$output_pr_text->tagConfigure('boldy', -font => "Courier -12 bold", -foreground=>'black');

my $final_frame = $main_frame->Frame(-borderwidth=>2, -relief=>'flat');
my $final_label= $final_frame->Label(-text=>"\ndrugOn installation in now finished.\nYou can run drugOn by opening a terminal window,\ncding to the installation folder and running ./drugOn.pl,\n or from the launcher at the applications menu.\n\nGo burn some rubber...\n",-justify=>'left', -anchor=>'w',-borderwidth=>0)->pack(-side=>'top', -pady => 0,-padx=>2, -expand => 0, -fill => 'x');


my $next_button = $button_frame->Button(-text => "Next", -width => $button_size, -command => \&next_callback)->pack( -side => 'right', -fill => 'y', -expand => 0);
my $previous_button = $button_frame->Button(-text => "Previous", -width => $button_size, -command => \&prev_callback, -state => 'disabled')->pack( -side => 'right', -fill => 'y', -expand => 0);
my $cancel_button = $button_frame->Button(-text => "Cancel", -width => $button_size, -command => \&quit_callback)->pack( -side => 'left', -fill => 'y', -expand => 0);

$mw->update;
$mw->deiconify;
MainLoop();

# ----------------------------------------------
#
# ----------------------------------------------

sub next_callback() {

	if ($tab == 1) {
		$start_frame->packForget;
		$drdep_frame->pack(-side => 'top', -anchor => 'nw', -expand => 1, -fill => 'both');
		$previous_button->configure(-state => 'normal');
		$next_button->configure(-text => 'Install');
		$tab++;
	} elsif ($tab == 2) {
		unless ($install_dir) {
			$mw -> MsgBox( -title => 'Install drugOn', -message=>"You must first provide an installation path for drugOn.",-type=>'ok',-icon=>'warning')->Show;
		} else {
			$drdep_frame->packForget;
			$dr_install_frame->pack(-side => 'top', -anchor => 'nw', -expand => 1, -fill => 'both');
			$previous_button->configure(-state => 'disabled');
			$next_button->configure(-state => 'disabled');
			$tab++;
			my $status = &install_dep_drugOn(); # 0 for success
		}
	} elsif ($tab == 3) {
		$dr_install_frame->packForget;
		$add_install_frame->pack(-side => 'top', -anchor => 'nw', -expand => 1, -fill => 'both');
		$next_button->configure(-text => 'Install');
		$tab++;
	} elsif ($tab == 4) {
		unless (&check_fields) {
			$mw -> MsgBox( -title => 'Install drugOn', -message=>"You must first provide installation files and paths for the selected software.",-type=>'ok',-icon=>'warning')->Show;
		} else {
			$add_install_frame->packForget;
			$add_install_pr_frame->pack(-side => 'top', -anchor => 'nw', -expand => 1, -fill => 'both');
			$previous_button->configure(-state => 'disabled');
			$next_button->configure(-state => 'disabled');
			$tab++;
			my $status = &install_ext_sof(0); # 0 for success
		}
	} elsif ($tab == 5) {
		$add_install_pr_frame->packForget;
		$final_frame->pack(-side => 'top', -anchor => 'nw', -expand => 1, -fill => 'both');
		$next_button->configure(-text => 'Finish');
		$cancel_button->configure(-state => 'disabled');
		$tab++;
	} elsif ($tab == 6) {
		$mw->destroy;
		#if ($launch) {
			#exec("bash -ic 'perl $install_dir/drugOn_v1.1/drugOn.pl' &");
		#}
	} else {}
	
}

sub prev_callback() {

	if ($tab == 2) {
		$drdep_frame->packForget;
		$start_frame->pack(-side => 'top', -anchor => 'nw', -expand => 1, -fill => 'both');
		$previous_button->configure(-state => 'disable');
		$next_button->configure(-text => 'Next');
		$tab--;
	} elsif ($tab == 3) {
		$dr_install_frame->packForget;
		$drdep_frame->pack(-side => 'top', -anchor => 'nw', -expand => 1, -fill => 'both');
		$previous_button->configure(-state => 'normal');
		$next_button->configure(-state => 'normal');
		$next_button->configure(-text => 'Install');
		$tab--;
	} elsif ($tab == 4) {
		$add_install_frame->packForget;
		$drdep_frame->pack(-side => 'top', -anchor => 'nw', -expand => 1, -fill => 'both');
		$next_button->configure(-text => 'Install');
		$tab--;
		$tab--;
	} elsif ($tab == 5) {
		$add_install_pr_frame->packForget;
		$add_install_frame->pack(-side => 'top', -anchor => 'nw', -expand => 1, -fill => 'both');
		$next_button->configure(-text => 'Install');
		$tab--;
	} elsif ($tab == 6) {
		$final_frame->packForget;
		$add_install_frame->pack(-side => 'top', -anchor => 'nw', -expand => 1, -fill => 'both');
		$next_button->configure(-text => 'Install');
		$cancel_button->configure(-state => 'normal');
		$tab--;
		$tab--;
	} else {}
	
}

sub quit_callback {
	my $d = $mw -> MsgBox( -title => 'Quit', -message=>"Installation Process is not finished.\nDo you really want to quit?",-type=>'yesno',-icon=>'question');
	my $button = $d->Show;
	if( $button eq "yes" ) {
		kill 1, $pid if ($pid);
		$mw->destroy;
	}
}

sub linux_entry_callback {
	my ($widjet,$text) = @_;
	
	@deps = @deps_u_13_10 if ($text eq 'Ubuntu 13.10');
	@deps = @deps_u_12_04 if ($text eq 'Ubuntu 12.04');
	
	
}

sub browse_directory_callback {
	my ($text) = @_;
	
	my $dir = $mw->DirSelect(-title => 'Choose Directory')->Show();
	if (defined $dir) {
		if (-d $dir) {
			$$text = $dir;
		}
	} else {}
}

sub browse_file_callback {
	my ($text) = @_;
		
	my $types=[];
	push @$types, ['tar.gz files', '*.tar.gz'];
	push @$types, ['All files', '*'];
	my $file;
	$file = $mw->getOpenFile(-filetypes=>$types);
	if (defined $file) {
		$$text = $file if (-e $file);
	}	
}

sub browse_file_zip_callback {
	my ($text) = @_;
		
	my $types=[];
	push @$types, ['zip files', '*.zip'];
	push @$types, ['All files', '*'];
	my $file;
	$file = $mw->getOpenFile(-filetypes=>$types);
	if (defined $file) {
		$$text = $file if (-e $file);
	}	
}

sub check_fields {
	if ($pdb2pqr) {
		return 0 unless ($pdb2pqr_file && $pdb2pqr_dir);
	}
	if ($ligbuilder) {
		return 0 unless ($ligbuilder_file && $ligbuilder_dir);
	}
	if ($ligbuilder_2) {
		return 0 unless ($ligbuilder_2_file && $ligbuilder_2_dir);
	}
	return 1;
}

sub rainbow {
    my @colors = (  0, '#00FF00',  1, '#00FF00',  2, '#00FF00',  3, '#00FF00',  4, '#00FF00',
		    5, '#00FF00',  6, '#00FF00',  7, '#00FF00',  8, '#00FF00',  9, '#00FF00',
		    10, '#00FF00', 11, '#00FF00', 12, '#00FF00', 13, '#00FF00', 14, '#00FF00',
		    15, '#00FF00', 16, '#00FF00', 17, '#00FF00', 18, '#00FF00', 19, '#00FF00',
		    20, '#00FF00', 21, '#00FF00', 22, '#00FF00', 23, '#00FF00', 24, '#00FF00',
		    25, '#00FF00', 26, '#00FF00', 27, '#00FF00', 28, '#00FF00', 29, '#00FF00',
		    30, '#00FF00', 31, '#00FF00', 32, '#00FF00', 33, '#00FF00', 34, '#00FF00',
		    35, '#00FF00', 36, '#00FF00', 37, '#00FF00', 38, '#00FF00', 39, '#00FF00',
		    40, '#00FF00', 41, '#00FF00', 42, '#00FF00', 43, '#00FF00', 44, '#00FF00',
		    45, '#00FF00', 46, '#00FF00', 47, '#00FF00', 48, '#00FF00', 49, '#00FF00',
		    50, '#00FF00', 51, '#00FF00', 52, '#00FF00', 53, '#00FF00', 54, '#00FF00',
		    55, '#00FF00', 56, '#00FF00', 57, '#00FF00', 58, '#00FF00', 59, '#00FF00',
		    60, '#00FF00', 61, '#00FF00', 62, '#00FF00', 63, '#00FF00', 64, '#00FF00',
		    65, '#00FF00', 66, '#00FF00', 67, '#00FF00', 68, '#00FF00', 69, '#00FF00',
		    70, '#00FF00', 71, '#00FF00', 72, '#00FF00', 73, '#00FF00', 74, '#00FF00',
		    75, '#00FF00', 76, '#00FF00', 77, '#00FF00', 78, '#00FF00', 79, '#00FF00',
		    80, '#00FF00', 81, '#00FF00', 82, '#00FF00', 83, '#00FF00', 84, '#00FF00',
		    85, '#00FF00', 86, '#00FF00', 87, '#00FF00', 88, '#00FF00', 89, '#00FF00',
		    90, '#00FF00', 91, '#00FF00', 92, '#00FF00', 93, '#00FF00', 94, '#00FF00',
		    95, '#00FF00', 96, '#00FF00', 97, '#00FF00', 98, '#00FF00', 99, '#00FF00' );
		    	    
    return \@colors;
}

sub install_dep_drugOn {
	$output_text->insert('end', "----------\nInstalling drugOn and dependencies for $linux_distro.\n----------\n\n",'orange'); # $command_history_text->SetCursor('end');
	my @cor_list;
	my $prog_bar_size;
	my $cmd;
	$mw->update;
	if($linux_distro eq 'Ubuntu 12.04') {
		@cor_list=@deps_u_12_04;
		# system("sudo apt-get -q -y update") and pre_die('Error updating repository');
		$cmd = 'sudo apt-get install -q -y';
	}elsif ($linux_distro eq 'Ubuntu 13.10') {
		@cor_list=@deps_u_13_10;
		# system("sudo apt-get -q -y update") and pre_die('Error updating repository');
		$cmd = 'sudo apt-get install -q -y';
	}
	$prog_bar_size=scalar(@cor_list) - 1;
	my $cur_step = 0;
	my $offset = 0;
	
	$output_text->insert('end', "Installing Dependencies...\n----------\n",'boldy');
	
	$cur_step++;
	my $flag;
	my $cmd_handle;
	my $temp_index = $cur_step + $offset;
	$output_text->insert('end', "$cmd $cor_list[$temp_index]\n",'boldy');
	$pid = open ($cmd_handle, "$stdbuf_str $cmd $cor_list[$temp_index] 2>&1 |") or $flag = $!;
	# system("$cmd $cor_list[$temp_index]") and pre_die('error');
	unless ($flag){
		$mw->fileevent($cmd_handle,'readable', [\&working,$cmd_handle,$prog_bar_size,$cur_step,$offset,$cmd,@cor_list]);
	} else {
		$output_text->insert('end', "\nAn error has occurred trying to run '$stdbuf_str $cmd $cor_list[$temp_index]':\n$!\n\n",'boldy');
		$output_text->insert('end', "----------\nInstallation encountered an error and aborted.\n----------\n\n",'orange'); # $command_history_text->SetCursor('end');
		$previous_button->configure(-state => 'normal');
		$next_button->configure(-state => 'normal');
		$next_button->configure(-text => 'Next');
		$progress = 0;			
	}
	#return 0;
}

sub working {
	my ($cmd_handle,$prog_bar_size,$cur_step,$offset,$cmd,@cor_list) = @_;
	
	my $redline;
	my $stat = sysread $cmd_handle, $redline, 4096;
	unless ($stat == 0) {
		$output_text->insert('end', "$redline");
		$output_text->yview('end');
	} else {
		$mw->fileevent($cmd_handle ,'readable','');
		&update_remaining(\$progress,$cur_step,$prog_bar_size);
		my $status = &parse_and_check();
		if ($status) {
			# print $status;
			### TODO Error details by parsing $status...
			$mw -> MsgBox( -title => 'Install drugOn', -message=>"An error occured during drugOn installation.\nRead the output in the Installation Progress window to find out what went wrong...\n",-type=>'ok',-icon=>'error')->Show;
			$output_text->insert('end', "\n----------\nInstallation encountered an error and aborted.\n----------\n\n",'orange'); # $command_history_text->SetCursor('end');
			$previous_button->configure(-state => 'normal');
			$next_button->configure(-state => 'normal');
			$next_button->configure(-text => 'Next');
			$progress = 0;
			return 256;
		}
		
		$cur_step++;
		unless (($cur_step + $offset) > $prog_bar_size) {
			if ($cor_list[$cur_step] eq '---CPAN---') {
				$offset = 1;	
				if ($linux_distro eq 'Ubuntu 12.04') {
					$cmd = 'sudo cpanm -q -n';
				}elsif ($linux_distro eq 'Ubuntu 13.10') {
					$cmd = 'sudo cpanm -q -n';
				}	
			}
			my $flag;
			my $cmd_handle;
			my $temp_index = $cur_step + $offset;
			$output_text->insert('end', "$cmd $cor_list[$temp_index]\n",'boldy');
			$pid = open ($cmd_handle, "$stdbuf_str $cmd $cor_list[$temp_index] 2>&1 |") or $flag = $!;
			unless ($flag){
				$mw->fileevent($cmd_handle,'readable', [\&working,$cmd_handle,$prog_bar_size,$cur_step,$offset,$cmd,@cor_list]);
				# &update_remaining($pb,$cur_step,$prog_bar_size);
			} else {
				$output_text->insert('end', "\nAn error has occurred trying to run '$stdbuf_str $cmd $cor_list[$temp_index]':\n$!\n\n",'boldy');
				$output_text->insert('end', "----------\nInstallation encountered an error and aborted.\n----------\n\n",'orange'); # $command_history_text->SetCursor('end');
				$previous_button->configure(-state => 'normal');
				$next_button->configure(-state => 'normal');
				$next_button->configure(-text => 'Next');
				$progress = 0;
			}
		} else {
			$output_text->insert('end', "\nInstalling Dependencies Finished.\n----------\n",'boldy');$output_text->yview('end');
			$output_text->insert('end', "\nInstalling drugOn...\n----------\n",'boldy');$output_text->yview('end');
			$output_text->insert('end', "Checking if drugOn_v1.1 folder already exists...");$output_text->yview('end');
			my $skipped = 0;
			if (-d File::Spec->catdir($install_dir,'drugOn_v1.1')) {
				my $d = $mw -> MsgBox( -title => 'Quit', -message=>"A folder named 'drugOn_v1.1' already exists.\nDo you want to overwrite the existing files?\n\nWARNING: The existing folder and all its contents will be deleted.",-type=>'yesno',-icon=>'question');
				my $button = $d->Show;
				if( $button eq "no" ) {
					$output_text->insert('end', "Yes\nSkipped copying files.\n");$output_text->yview('end');
					$output_text->insert('end', "----------\n",'boldy');$output_text->yview('end');
					$skipped = 1;
				} else {
					$output_text->insert('end', "Yes\nDeleting old files...");$output_text->yview('end');
					system "rm -r ".File::Spec->catdir($install_dir,'drugOn_v1.1') and pre_die("deleting folder returned $?\n");
				}
			}
			unless ($skipped) {		
				$output_text->insert('end', "Done\n");$output_text->yview('end');
				$output_text->insert('end', "Creating folder and copying files...");$output_text->yview('end');
				system "cp -a $drugOn_directory ".File::Spec->catdir($install_dir,'drugOn_v1.1') and pre_die("copying files returned $?\n");
				$output_text->insert('end', "Done\n");$output_text->yview('end');
				if ($app_launcher_pro) {
					$output_text->insert('end', "Creating Application Launcher...");$output_text->yview('end');
					system "mkdir -p /usr/share/applications" and pre_die("creating /usr/share/applications returned $?\n");
					open OUT, '>', File::Spec->catdir('/','usr','share','applications','drugOn pro.desktop') or pre_die("error creating drugOn.desktop: $!");
					print OUT "[Desktop Entry]\nVersion=1.1\nType=Application\nName=drugOn_pro\nComment=Software Suite for Computer Assisted Drug Discovery\nCategories=Scientific;Tools;\nIcon=$install_dir/drugOn_v1.1/Icons/DrugOn.png\nExec=bash -ic 'perl $install_dir/drugOn_v1.1/drugOn_pro.pl'\nTerminal=true\n";
					close OUT;
					$output_text->insert('end', "Done\n");$output_text->yview('end');
				}
				if ($app_launcher) {
					$output_text->insert('end', "Creating Application Launcher...");$output_text->yview('end');
					system "mkdir -p /usr/share/applications" and pre_die("creating /usr/share/applications returned $?\n");
					open OUT, '>', File::Spec->catdir('/','usr','share','applications','drugOn.desktop') or pre_die("error creating drugOn.desktop: $!");
					print OUT "[Desktop Entry]\nVersion=1.1\nType=Application\nName=drugOn\nComment=Software Suite for Computer Assisted Drug Discovery\nCategories=Scientific;Tools;\nIcon=$install_dir/drugOn_v1.1/Icons/DrugOn.png\nExec=bash -ic 'perl $install_dir/drugOn_v1.1/drugOn.pl'\nTerminal=true\n";
					close OUT;
					$output_text->insert('end', "Done\n");$output_text->yview('end');
				}
			}
			$progress = 100;
			$output_text->insert('end', "\nInstalling drugOn Finished.\n----------\n",'boldy');$output_text->yview('end');
			$mw -> MsgBox( -title => 'Install drugOn', -message=>"drugOn and its dependencies were successfully installed.\nPress next to install external/additional software needed in drugOn.",-type=>'ok',-icon=>'info')->Show;
			$output_text->insert('end', "\n----------\nInstallation was successfully completed.\n----------\n\n",'orange'); # $command_history_text->SetCursor('end');
			$output_text->yview('end');
			$previous_button->configure(-state => 'normal');
			$next_button->configure(-state => 'normal');
			$next_button->configure(-text => 'Next');
			$progress = 0;
		}
	}
}

sub parse_and_check_pdb2pqr {
	my $errors = '';
	my $sucess_tag = $output_text->search(-backwards,-nocase,'PDB2PQR has been installed','end');
	if ($sucess_tag) {
		return 0;
	} else {
		return $sucess_tag;
	}
}


sub parse_and_check {
	my $errors = '';
	my $error_tag = $output_text->search(-backwards,'invalid','end');
	if ($error_tag) {
		my @asd = $output_text->tagNames($error_tag);
		unless ($asd[0] && ($asd[0] eq 'boldy')) {
			(my $line,my $index) = split(/\./,$error_tag,2);
			# my $line2= $line + 1;
			$output_text->tagAdd('boldy',"$line.0","$line.end");
			$errors = $errors.'invalid ';
		}
	}
	$error_tag = '';
	# $error_tag = $output_text->search(-backwards,-nocase,'error','end');
	# if ($error_tag) {
		# unless ($output_text->tagNames($error_tag) eq 'boldy') {
			# (my $line,my $index) = split(/\./,$error_tag,2);
			# # my $line2= $line + 1;
			# $output_text->tagAdd('boldy',"$line.0","$line.end");
			# $errors = $errors.'error ';
		# }
	# }
	# $error_tag = '';
	$error_tag = $output_text->search(-backwards,-nocase,'failed','end');
	if ($error_tag) {
		my @asd = $output_text->tagNames($error_tag);
		unless ($asd[0] && ($asd[0] eq 'boldy')) {
			(my $line,my $index) = split(/\./,$error_tag,2);
			# my $line2= $line + 1;
			$output_text->tagAdd('boldy',"$line.0","$line.end");
			$errors = $errors.'failed ';
		}
	}
	$error_tag = '';
	$error_tag = $output_text->search(-backwards,"Can't write",'end');
	if ($error_tag) {
		my @asd = $output_text->tagNames($error_tag);
		unless ($asd[0] && ($asd[0] eq 'boldy')) {
			(my $line,my $index) = split(/\./,$error_tag,2);
			# my $line2= $line + 1;
			$output_text->tagAdd('boldy',"$line.0","$line.end");
			$errors = $errors.'write ';
		}
	}
	$error_tag = '';
	$error_tag = $output_text->search(-backwards,-regexp,'^E:','end');
	if ($error_tag) {
		my @asd = $output_text->tagNames($error_tag);
		unless ($asd[0] && ($asd[0] eq 'boldy')) {
			(my $line,my $index) = split(/\./,$error_tag,2);
			# my $line2= $line + 1;
			$output_text->tagAdd('boldy',"$line.0","$line.end");
			$errors = $errors.'E: ';
		}
	}
	$error_tag = '';
	$error_tag = $output_text->search(-backwards,'! ','end');
	if ($error_tag) {
		my @asd = $output_text->tagNames($error_tag);
		unless ($asd[0] && ($asd[0] eq 'boldy')) {
			(my $line,my $index) = split(/\./,$error_tag,2);
			# my $line2= $line + 1;
			$output_text->tagAdd('boldy',"$line.0","$line.end");
			$errors = $errors.'! ';
		}
	}
	$error_tag = '';
	return $errors;
}


sub update_remaining {
	my ($progress,$cur_step,$prog_bar_size) = @_;
	my $temp = 100 * ($cur_step/$prog_bar_size);
	$$progress = $temp;
	# print $pb,$cur_step,$prog_bar_size;
	$mw->update;
}

sub install_ext_sof {
	my ($opt) = @_;
	if ($opt == 0) {
		unless ($pdb2pqr || $gromacs || $ligbuilder || $ligbuilder_2 || $pharmACOphore|| $pymol) {
			$mw -> MsgBox( -title => 'Install Additional Software', -message=>"No additional software was selected for installation.\nPress next to finish installation.",-type=>'ok',-icon=>'info')->Show;
			$output_pr_text->insert('end', "----------\nNo Additional Software was selected for\ninstallation.\n----------\n\n",'orange'); # $command_history_text->SetCursor('end');
			$previous_button->configure(-state => 'normal');
			$next_button->configure(-state => 'normal');
			$next_button->configure(-text => 'Next');
			$progress_pr = 0;
		} else {
			$output_pr_text->insert('end', "----------\nInstalling Additional Software.\n----------\n",'orange'); # $command_history_text->SetCursor('end');
			my $cmd;
			if ($linux_distro eq 'Ubuntu 12.04') {
				$cmd = 'sudo apt-get install -q -y python python-dev g++ flex gfortran bison';
			}elsif ($linux_distro eq 'Ubuntu 13.10') {
				$cmd = 'sudo apt-get install -q -y python python-dev g++ flex gfortran bison';
			}
			my $flag;
			my $cmd_handle;
			$output_pr_text->insert('end', "\nInstall Necessary Dependencies for Additional Software\n----------\n$cmd\n",'boldy');
			$pid = open ($cmd_handle, "$stdbuf_str $cmd 2>&1 |") or $flag = $!;
			unless ($flag){
				$mw->fileevent($cmd_handle,'readable', [\&working_gro_pym,$cmd_handle,1]);
			} else {
				$output_pr_text->insert('end', "\nAn error has occurred trying to run '$stdbuf_str $cmd':\n$!\n\n",'boldy');
				$output_pr_text->insert('end', "----------\nInstallation encountered an error and aborted.\n----------\n\n",'orange'); # $command_history_text->SetCursor('end');
				$previous_button->configure(-state => 'normal');
				$next_button->configure(-state => 'normal');
				$next_button->configure(-text => 'Next');
				$progress_pr = 0;			
			}
		}
	} elsif ($opt == 1) {
		if ($pdb2pqr) {
			$output_pr_text->insert('end', "\nInstall Pdb2pqr\n----------\n",'boldy');
			my $abs_pdb2pqr_file = File::Spec->rel2abs($pdb2pqr_file);
			my ($volume,$directories,$pdb2pqr_name) = File::Spec->splitpath($abs_pdb2pqr_file);
			$pdb2pqr_name =~ s/.tar.gz$//;
			$output_pr_text->insert('end', "Untarring installation archive...",'boldy');
			my $oldwd = getcwd();
			chdir $directories or pre_die("$directories: $!\n");
			system("tar -xf $abs_pdb2pqr_file") and pre_die("Error untarring $pdb2pqr_file");
			$output_pr_text->insert('end', "Done\n",'boldy');$output_pr_text->yview('end');
			$mw->update;
			# my $oldwd = getcwd();
			chdir File::Spec->catdir($directories,$pdb2pqr_name) or pre_die("$directories/$pdb2pqr_name: $!\n");
			$output_pr_text->insert('end', "Configuring Pdb2pqr...",'boldy');
			$mw->update;
			system("./configure --enable-propka --disable-pdb2pka --prefix $pdb2pqr_dir") and pre_die("Error configuring pdb2pqr");
			$output_pr_text->insert('end', "Done\n",'boldy');$output_pr_text->yview('end');
			$output_pr_text->insert('end', "Make Pdb2pqr...",'boldy');
			$mw->update;
			system("make 2>&1") and pre_die("Error make pdb2pqr");
			$output_pr_text->insert('end', "Done\n",'boldy');$output_pr_text->yview('end');
			$mw->update;
			my $flag;
			my $cmd_handle;
			$pid = open ($cmd_handle, "$stdbuf_str make install 2>&1 |") or $flag = $!;
			chdir "$oldwd" or pre_die("Can't cd to $oldwd: $!\n");
			unless ($flag){
				$output_pr_text->insert('end', "Make Install Pdb2pqr\n",'boldy');
				$mw->update;
				$mw->fileevent($cmd_handle,'readable', [\&working_gro_pym,$cmd_handle,2]);
			} else {
				$output_pr_text->insert('end', "\nAn error has occurred trying to run '$stdbuf_str make install':\n$!\n\n",'boldy');
				$output_pr_text->insert('end', "----------\nInstallation encountered an error and aborted.\n----------\n\n",'orange'); # $command_history_text->SetCursor('end');
				$previous_button->configure(-state => 'normal');
				$next_button->configure(-state => 'normal');
				$next_button->configure(-text => 'Next');
				$progress_pr = 0;			
			}
		} else {
			$output_pr_text->insert('end', "\nSkipping Pdb2pqr Installation\n----------\n",'boldy');
			$progress_pr = 30;
			install_ext_sof(2);
		}
	} elsif ($opt == 2) {
		if ($gromacs) {
			my $cmd;
			if ($linux_distro eq 'Ubuntu 12.04') {
				$cmd = 'sudo apt-get install -q -y gromacs grace';
			}elsif ($linux_distro eq 'Ubuntu 13.10') {
				$cmd = 'sudo apt-get install -q -y gromacs grace';
			}
			my $flag;
			my $cmd_handle;
			$output_pr_text->insert('end', "\nInstall Gromacs\n----------\n$cmd\n",'boldy');
			$pid = open ($cmd_handle, "$stdbuf_str $cmd 2>&1 |") or $flag = $!;
			unless ($flag){
				$mw->fileevent($cmd_handle,'readable', [\&working_gro_pym,$cmd_handle,3]);
			} else {
				$output_pr_text->insert('end', "\nAn error has occurred trying to run '$stdbuf_str $cmd':\n$!\n\n",'boldy');
				$output_pr_text->insert('end', "----------\nInstallation encountered an error and aborted.\n----------\n\n",'orange'); # $command_history_text->SetCursor('end');
				$previous_button->configure(-state => 'normal');
				$next_button->configure(-state => 'normal');
				$next_button->configure(-text => 'Next');
				$progress_pr = 0;			
			}
		} else {
			$output_pr_text->insert('end', "\nSkipping Gromacs Installation\n----------\n",'boldy');
			$progress_pr = 40;
			install_ext_sof(3);
		}
	} elsif ($opt == 3) {
		if ($ligbuilder) {
			$output_pr_text->insert('end', "\nInstall LigBuilder v1.2\n----------\n",'boldy');
			my $abs_ligbuilder_file = File::Spec->rel2abs($ligbuilder_file);
			my ($volume,$directories,$ligbuilder_name) = File::Spec->splitpath($abs_ligbuilder_file);
			$ligbuilder_name =~ s/.zip$//;
			$output_pr_text->insert('end', "Unzipping installation archive...",'boldy');
			my $oldwd = getcwd();
			chdir $directories or pre_die("$directories: $!\n");
			system("unzip -oq $abs_ligbuilder_file") and pre_die("Error Unzipping $ligbuilder_file");
			$output_pr_text->insert('end', "Done\n",'boldy');$output_pr_text->yview('end');
			$mw->update;
			# my $oldwd = getcwd();
			chdir File::Spec->catdir($directories,$ligbuilder_name,'pocket') or pre_die("$directories/$ligbuilder_name/pocket: $!\n");
			$output_pr_text->insert('end', "Make pocket...",'boldy');
			$mw->update;
			system('/usr/bin/perl -p -i -e "s/CC\s+=\s+CC/CC = g\+\+/g" Makefile') and pre_die("Error changing cc: $!");
			system("make") and pre_die("Error make pocket");
			system("cp pocket ../bin") and pre_die("Error cp pocket");
			$output_pr_text->insert('end', "Done\n",'boldy');$output_pr_text->yview('end');
			$mw->update;
			chdir File::Spec->catdir($directories,$ligbuilder_name,'grow') or pre_die("$directories/$ligbuilder_name/grow: $!\n");
			$output_pr_text->insert('end', "Make grow...",'boldy');
			$mw->update;
			system('/usr/bin/perl -p -i -e "s/CC\s+=\s+CC/CC = g\+\+/g" Makefile') and pre_die("Error changing cc: $!");
			system("make") and pre_die("Error make grow");
			system("cp grow ../bin") and pre_die("Error cp grow");
			$output_pr_text->insert('end', "Done\n",'boldy');$output_pr_text->yview('end');
			$mw->update;
			chdir File::Spec->catdir($directories,$ligbuilder_name,'link') or pre_die("$directories/$ligbuilder_name/link: $!\n");
			$output_pr_text->insert('end', "Make link...",'boldy');
			$mw->update;
			system('/usr/bin/perl -p -i -e "s/CC\s+=\s+CC/CC = g\+\+/g" Makefile') and pre_die("Error changing cc: $!");
			system("make") and pre_die("Error make link");
			system("cp link ../bin") and pre_die("Error cp link");
			$output_pr_text->insert('end', "Done\n",'boldy');$output_pr_text->yview('end');
			$mw->update;
			chdir File::Spec->catdir($directories,$ligbuilder_name,'process') or pre_die("$directories/$ligbuilder_name/process: $!\n");
			$output_pr_text->insert('end', "Make process...",'boldy');
			$mw->update;
			system('/usr/bin/perl -p -i -e "s/CC\s+=\s+CC/CC = g\+\+/g" Makefile') and pre_die("Error changing cc: $!");
			system("make") and pre_die("Error make process");
			system("cp process ../bin") and pre_die("Error cp process");
			$output_pr_text->insert('end', "Done\n",'boldy');$output_pr_text->yview('end');
			$output_pr_text->insert('end', "Copying to desired location...",'boldy');
			$mw->update;
			if (File::Spec->rel2abs($directories) eq File::Spec->rel2abs($ligbuilder_dir)) {
				$output_pr_text->insert('end', "Already there\n",'boldy');
			} else {
				system("cp -a ".File::Spec->catdir($directories,$ligbuilder_name)." $ligbuilder_dir") and pre_die("Error copying LigBuilder v1.2 Files");
				$output_pr_text->insert('end', "Done\n",'boldy');$output_pr_text->yview('end');
			}
			$mw->update;
			chdir File::Spec->catdir($ligbuilder_dir,'LigBuilderv1.2','bin') or pre_die("$ligbuilder_dir/bin: $!\n");
			$output_pr_text->insert('end', "Chmod +x...",'boldy');
			$mw->update;
			system("chmod +x pocket") and pre_die("Error chmod");
			system("chmod +x grow") and pre_die("Error chmod");
			system("chmod +x link") and pre_die("Error chmod");
			system("chmod +x process") and pre_die("Error chmod");
			$output_pr_text->insert('end', "Done\n",'boldy');$output_pr_text->yview('end');
			$mw->update;
			chdir "$oldwd" or pre_die("Can't cd to $oldwd: $!\n");
			$progress_pr = 50;
			install_ext_sof(4);
		} else {
			$output_pr_text->insert('end', "\nSkipping LigBuilder v1.2 Installation\n----------\n",'boldy');
			$progress_pr = 50;
			install_ext_sof(4);
		}
	} elsif ($opt == 4) {
		if ($ligbuilder_2) {
			$output_pr_text->insert('end', "\nInstall LigBuilder v2.0\n----------\n",'boldy');
			my $abs_ligbuilder_2_file = File::Spec->rel2abs($ligbuilder_2_file);
			my ($volume,$directories,$ligbuilder_2_name) = File::Spec->splitpath($abs_ligbuilder_2_file);
			$ligbuilder_2_name =~ s/.tar.gz$//;
			$output_pr_text->insert('end', "Untaring installation archive...",'boldy');
			my $oldwd = getcwd();
			chdir $directories or pre_die("$directories: $!\n");
			system("tar -xf $abs_ligbuilder_2_file") and pre_die("Error Untaring $abs_ligbuilder_2_file");
			$output_pr_text->insert('end', "Done\n",'boldy');$output_pr_text->yview('end');
			$mw->update;
			$output_pr_text->insert('end', "Copying to desired location...",'boldy');
			$mw->update;
			if (File::Spec->rel2abs($directories) eq File::Spec->rel2abs($ligbuilder_2_dir)) {
				$output_pr_text->insert('end', "Already there\n",'boldy');
			} else {
				system("cp -a ".File::Spec->catdir($directories,$ligbuilder_2_name)." $ligbuilder_2_dir") and pre_die("Error copying LigBuilder v2.0 Files");
				$output_pr_text->insert('end', "Done\n",'boldy');$output_pr_text->yview('end');
			}
			$mw->update;
			# my $oldwd = getcwd();
			chdir File::Spec->catdir($directories,$ligbuilder_2_name) or pre_die("$directories/$ligbuilder_2_name: $!\n");
			$output_pr_text->insert('end', "Configuring LigBuilder v2.0...",'boldy');
			$mw->update;
			system("./configure") and pre_die("Error configuring LigBuilder v2.0");
			$output_pr_text->insert('end', "Done\n",'boldy');$output_pr_text->yview('end');
			$mw->update;
			chdir "$oldwd" or pre_die("Can't cd to $oldwd: $!\n");
			$progress_pr = 60;
			install_ext_sof(5);
		} else {
			$output_pr_text->insert('end', "\nSkipping LigBuilder v2.0 Installation\n----------\n",'boldy');
			$progress_pr = 60;
			install_ext_sof(5);
		}
	} elsif ($opt == 5) {
		if ($pharmACOphore) {
			# TODO
			$pharmACOphore_dir = File::Spec->catfile($install_dir,'drugOn_v1.1','Pharmacophore_files');
			$output_pr_text->insert('end', "\nInstall PharmACOphore\n----------\n",'boldy');
			my $abs_pharmACOphore_file = File::Spec->rel2abs($pharmACOphore_file);
			my ($volume,$directories,$pharmACOphore_name) = File::Spec->splitpath($abs_pharmACOphore_file);			
			system("cp -a ".File::Spec->catdir($directories,$pharmACOphore_name)." $pharmACOphore_dir") and pre_die("Error copying PharmACOphore Files");
			$output_pr_text->insert('end', "Done\n",'boldy');$output_pr_text->yview('end');
			chdir File::Spec->catdir($install_dir,'drugOn_v1.1','Pharmacophore_files') or die "$install_dir/drugOn_v1.1/Pharmacophore_files: $!\n";
			system("chmod +x pharmACOphore") and pre_die ("Error changing mode");
			$progress_pr = 80;
			install_ext_sof(6);	
		
		 } else {
			 $output_pr_text->insert('end', "\nSkipping pharmACOphore Installation\n----------\n",'boldy');
			 $progress_pr = 80;
			 install_ext_sof(6);
		 }
	 }
	  elsif ($opt == 6) {
		if ($pymol) {
			 my $cmd;
			if ($linux_distro eq 'Ubuntu 12.04') {
				 $cmd = 'sudo apt-get install -q -y pymol';
			 }elsif ($linux_distro eq 'Ubuntu 13.10') {
				 $cmd = 'sudo apt-get install -q -y pymol';
			 }
			 my $flag;
			 my $cmd_handle;
			 $output_pr_text->insert('end', "\nInstall Pymol\n----------\n$cmd\n",'boldy');
			 $pid = open ($cmd_handle, "$stdbuf_str $cmd 2>&1 |") or $flag = $!;
			 unless ($flag){
				 $mw->fileevent($cmd_handle,'readable', [\&working_gro_pym,$cmd_handle,7]);
			 } else {
				 $output_pr_text->insert('end', "\nAn error has occurred trying to run '$stdbuf_str $cmd':\n$!\n\n",'boldy');
				 $output_pr_text->insert('end', "----------\nInstallation encountered an error and aborted.\n----------\n\n",'orange'); # $command_history_text->SetCursor('end');
				 $previous_button->configure(-state => 'normal');
				 $next_button->configure(-state => 'normal');
				 $next_button->configure(-text => 'Next');
				 $progress_pr = 0;			
			 }
	 } else {
			 $output_pr_text->insert('end', "\nSkipping Pymol Installation\n----------\n",'boldy');
			 $progress_pr = 90;
			 install_ext_sof(7);
		 }
	} elsif ($opt == 7) {
		$output_pr_text->insert('end', "\nWriting drugOn Configuration File\n----------\n",'boldy');
		### TODO write conf file
		open OUT, '>', File::Spec->catfile($install_dir,'drugOn_v1.1','.default_prefs') or pre_die("error writing default options");
		print OUT "#\n# Program Preferences\n#\n\n";
		print OUT "default_working_directory\t/home/user/Documents\n";
		print OUT "enable_fun\t0\n";
		print OUT "default_log_file\t/home/user/Documents/drugOn_log_file.log\n";
		print OUT "enable_log\t0\n";
		print OUT "pdb2pqr_path\t/var/www/html/pdb2pqr\n";
		print OUT "gromacs_path\t\n";
		print OUT "ligbuilder_path\t".File::Spec->catdir($ligbuilder_dir,'LigBuilderv1.2')."\n";
		print OUT "ligbuilder_20_path\t".File::Spec->catdir($ligbuilder_2_dir,'LigBuilderV2')."\n";
		print OUT "pharmACOphore_path\t".File::Spec->catdir($pharmACOphore_dir)."\n";
		print OUT "default_gromacs_param_file\t".File::Spec->catdir($install_dir,'drugOn_v1.1/Parameter_Files/em_1.mdp')."\n";;
		print OUT "default_pocket_param_file\t\n";
		print OUT "default_grow_param_file\t\n";
		print OUT "default_link_param_file\t\n";
		print OUT "default_process_param_file\t\n";
		print OUT "default_cavity_param_file\t\n";
		print OUT "default_build_param_file\t\n";
		print OUT "default_dock_param_folder\t\n";
		print OUT "preferred_terminal\t/usr/bin/gnome-terminal --working-directory=\$working_directory\n";
		print OUT "preferred_file_manager\t/usr/bin/nautilus\n";
		print OUT "preferred_text_editor\t/usr/bin/gedit\n";
		print OUT "preferred_mol_viewer\t/usr/bin/pymol\n";
		print OUT "preferred_graph_viewer\t/usr/bin/xmgrace\n";
		close OUT;
		system("cp ".File::Spec->catfile($install_dir,'drugOn_v1.1','.default_prefs')." ".File::Spec->catfile($install_dir,'drugOn_v1.1','.default_prefs.r')) and pre_die('Error copying conf file');
		$output_pr_text->insert('end', "Done\n----------\n",'boldy');
		$progress_pr = 100;
		# $output_pr_text->insert('end', "\nInstalling Additional Software Finished.\n----------\n",'boldy');$output_text->yview('end');
		$mw -> MsgBox( -title => 'Install Additional Software', -message=>"Additional Software was successfully installed.\nPress next to finish installation.",-type=>'ok',-icon=>'info')->Show;
		$output_pr_text->insert('end', "\n----------\nInstallation was successfully completed.\n----------\n\n",'orange'); # $command_history_text->SetCursor('end');
		$output_pr_text->yview('end');
		$previous_button->configure(-state => 'normal');
		$next_button->configure(-state => 'normal');
		$next_button->configure(-text => 'Next');
		$progress_pr = 0;
	} else {}
}		

sub working_gro_pym {
	my ($cmd_handle,$next) = @_;
	
	my $redline;
	my $stat = sysread $cmd_handle, $redline, 4096;
	unless ($stat == 0) {
		$output_pr_text->insert('end', "$redline");
		$output_pr_text->yview('end');
	} else {
		$mw->fileevent($cmd_handle ,'readable','');
		if ($next == 3) {
			$progress_pr = 40;
		} elsif ($next == 7) {
			$progress_pr = 90;
		} elsif ($next == 1) {
			$progress_pr = 20;
		} elsif ($next == 2) {
			$progress_pr = 30;
		} elsif ($next == 6) {
			$progress_pr = 80;
		}
		my $status;
		if ($next == 2) {
			$status = &parse_and_check_pdb2pqr();
		} elsif ($next == 6) {
			$status = &parse_and_check_dock();
		} else {
			$status = &parse_and_check();
		}
		if ($status) {
			# print $status;
			### TODO Error details by parsing $status...
			$mw -> MsgBox( -title => 'Install drugOn', -message=>"An error occured during Additional Software installation.\nRead the output in the Installation Progress window to find out what went wrong...\n",-type=>'ok',-icon=>'error')->Show;
			$output_pr_text->insert('end', "\n----------\nInstallation encountered an error and aborted.\n----------\n\n",'orange'); # $command_history_text->SetCursor('end');
			$previous_button->configure(-state => 'normal');
			$next_button->configure(-state => 'normal');
			$next_button->configure(-text => 'Next');
			$progress = 0;
			return 256;
		}
		&install_ext_sof($next);
	}
}

sub pre_die() {
	my ($err_mes) = @_;
	$mw -> MsgBox( -title => 'Install drugOn', -message=>"An unexpected error occured during installation.\n\n$err_mes\n\nInstallation will abort.\nIf you don't find a probable cause for this error, please contact the developers.",-type=>'ok',-icon=>'error')->Show;
	die($err_mes);
	
}

